/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2008 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.system.action;

import java.io.Serializable;
import java.util.Comparator;

import jp.mosp.common.dao.CmCodeDao;
import jp.mosp.common.dto.CmCodeDto;

import jp.mosp.common.action.MosPAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.system.vo.CmCodeListVo;

public class CmCodeListAction extends MosPAction {

	// コマンド
	private static final String CMD_CODE_CARD_SHOW      = "S2000";	// 表示
	private static final String CMD_CODE_CARD_SELECT    = "S2001";	// 検索
	private static final String CMD_CODE_LIST_RE_SEARCH = "S2002";	// 再検索
	private static final String CMD_CODE_CARD_SORT      = "S2003";	// ソート

	/**
	 * コンストラクタ
	 */
	public CmCodeListAction() {
		super();
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		// VOの取得
		CmCodeListVo vo;
		Object obj = session.getAttribute(MospConst.ATT_FORMER_VO);
		if (obj instanceof CmCodeListVo) {
			vo = (CmCodeListVo)obj;
			vo.clearMessage();
			vo.clearErrField();
		} else {
			vo = new CmCodeListVo();
		}		
		vo.clearMessage();
		vo.clearErrField();
		vo.initVo(cfg, msg, cmd, aspUser, user);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		session.setAttribute(MospConst.ATT_FORMER_VO, vo);
		// コマンド毎の処理
		if (cmd.equals(CMD_CODE_CARD_SHOW)) {
			// 表示処理
			getConnection();
			// コード区分プルダウンリスト作成
			vo.aryPltTId = getCodeArray();
			// 削除フラグのプルダウンリスト作成
			vo.setPltDelete(MospConst.DELETE_FLAG_OFF);
			// 検索履歴を初期値にセット
			vo.setSearchmode(0);
		} else if (cmd.equals(CMD_CODE_CARD_SELECT)) {
			// 検索処理
			vo.setParams(request);
			searchCodeList(vo);
			vo.setIsAscending(true);
			vo.initListInfo();
			// 検索履歴をありにセット
			vo.setSearchmode(1);
		} else if (cmd.equals(CMD_CODE_LIST_RE_SEARCH)) {
			// 再検索
			if(vo.getSearchmode() == 1){
				session.removeAttribute(MospConst.ATT_DTO);
				searchCodeList(vo);
				vo.setPageButton();
				sortList(vo);
			}
		} else if (cmd.equals(CMD_CODE_CARD_SORT)) {
			// ソート
			sortList(key1, vo);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	/**
	 * コードリスト検索
	 * @param vo CodeListVoインスタンス
	 * @throws Exception
	 */
	private void searchCodeList(CmCodeListVo vo) throws Exception {
		// DBコネクションの取得
		getConnection();
		// 検索
		CmCodeDao dao = new CmCodeDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		vo.setFields(dao.findForSearch(vo.getPltTId(),vo.getTxtTCode(),vo.getTxtTName(),vo.getPltDelete()));
		setCodeTypeName(vo);
		// 対象が無かった場合のメッセージ設定
		if (vo.getEscAryTCode().length == 0) {
			vo.addErrMessage(MospUtility.getMessage(msg, MospConst.MSG_NO_DATA, ""));
		}
	}

	/**
	 * コード区分名称設定
	 * @param vo CodeListVoインスタンス
	 */
	private void setCodeTypeName(CmCodeListVo vo) {
		String[] aryCodeTypeName = new String[vo.getList().size()];
		for (int i = 0; i < vo.getList().size(); i++) {
			CmCodeDto dto = (CmCodeDto)vo.getList().get(i);
			aryCodeTypeName[i] = getCodeTypeName(dto.getTId());
		}
		vo.setAryTIdName(aryCodeTypeName);
	}

	/**
	 * ソート
	 * @param key ソートキー
	 * @param vo ソート対象Listを含むVO
	 * @throws MospException
	 */
	private void sortList(String key, CmCodeListVo vo) throws MospException {
		vo.sortList(key, getComparator(key, vo));
		vo.setFields(vo.getList());
		setCodeTypeName(vo);
	}

	/**
	 * ソート(VO内のキー情報でソート)
	 * @param vo ソート対象Listを含むVO
	 * @throws MospException
	 */
	private void sortList(CmCodeListVo vo) throws MospException {
		vo.sortList(getComparator(vo.getFormerKey(), vo));
		vo.setFields(vo.getList());
		setCodeTypeName(vo);
	}

	/**
	 * 比較クラス取得
	 * @param key ソートキー
	 * @param vo ソート対象Listを含むVO
	 * @throws MospException
	 */
	private Comparator getComparator(String key, CmCodeListVo vo) throws MospException {
		Comparator comp = null;
		if (key.equals(vo.KEY_T_ID)) {
			comp = new CompTId();
		} else if (key.equals(vo.KEY_T_CODE)) {
			comp = new CompTCode();
		} else if (key.equals(vo.KEY_T_NAME)) {
			comp = new CompTName();
		} else if (key.equals(vo.KEY_VIEWINDEX)) {
			comp = new CompViewIndex();
		}else if (key.equals(vo.KEY_DELETE)) {
			comp = new CompDeleteFlag();
		} else {
			throw new MospException(MospConst.EX_SORTKEY_INVALID);
		}
		return comp;
	}

	/**
	 * コード区分による比較クラス
	 */
	protected static class CompTId implements Comparator, Serializable {
		private static final long serialVersionUID = 7210303772053153377L;
		public int compare(Object obj1, Object obj2) {
			CmCodeDto dto1 = (CmCodeDto)obj1;
			CmCodeDto dto2 = (CmCodeDto)obj2;
			return dto1.getTId().compareTo(dto2.getTId());
		}
	}

	/**
	 * コードによる比較クラス
	 */
	protected static class CompTCode implements Comparator, Serializable {
		private static final long serialVersionUID = 5672044129524635759L;
		public int compare(Object obj1, Object obj2) {
			CmCodeDto dto1 = (CmCodeDto)obj1;
			CmCodeDto dto2 = (CmCodeDto)obj2;
			return dto1.getTCode().compareTo(dto2.getTCode());
		}
	}

	/**
	 * コード名称による比較クラス
	 */
	protected static class CompTName implements Comparator, Serializable {
		private static final long serialVersionUID = -8615320106870669507L;
		public int compare(Object obj1, Object obj2) {
			CmCodeDto dto1 = (CmCodeDto)obj1;
			CmCodeDto dto2 = (CmCodeDto)obj2;
			return dto1.getTName().compareTo(dto2.getTName());
		}
	}

	/**
	 * 表示順による比較クラス
	 */
	protected static class CompViewIndex implements Comparator, Serializable {
		private static final long serialVersionUID = 2787828366453888987L;
		public int compare(Object obj1, Object obj2) {
			CmCodeDto dto1 = (CmCodeDto)obj1;
			CmCodeDto dto2 = (CmCodeDto)obj2;
			return dto1.getViewIndex() - (dto2.getViewIndex());
		}
	}

	/**
	 * 削除フラグによる比較クラス
	 */
	static class CompDeleteFlag implements Comparator, Serializable {
		private static final long serialVersionUID = -1824284390861851592L;
		public int compare(Object obj1, Object obj2) {
			CmCodeDto dto1 = (CmCodeDto)obj1;
			CmCodeDto dto2 = (CmCodeDto)obj2;
			return dto2.getDeleteFlag() - dto1.getDeleteFlag();
		}
	}

}
